#include <stdio.h>
#include <utility>
#include <string.h>
#include <limits.h>
#include <map>

using namespace std;

unsigned long N;

pair<unsigned long long, unsigned long> hodnoty[100000];

unsigned long long findmin(bool gt, unsigned long long L)
{
    map<unsigned long, int, greater<unsigned long> > mapa;
    mapa.clear();
    int indexposledniho = 0;
    int pocet = 0;
    for(int i = 0;i<N;i++)
    {

        while(hodnoty[i].first > L && hodnoty[indexposledniho].first < hodnoty[i].first - L)
        {
            mapa[hodnoty[indexposledniho].second]--;
            if(mapa[hodnoty[indexposledniho].second] == 0) mapa.erase(mapa.find(hodnoty[indexposledniho].second));
            indexposledniho++;
        }

        unsigned long minimum;
        if(mapa.size() > 0)
        {
            minimum = (*(--mapa.end())).first;
        } else {
            minimum = ULONG_MAX;
        }

        mapa[hodnoty[i].second]++;
        if(i - indexposledniho == 0) continue;

        if(gt)
        {
            if(hodnoty[i].second > minimum) pocet++;
        } else {
            if(hodnoty[i].second < minimum) pocet++;
        }


    }
    return pocet;
}

unsigned long long findmax(bool gt, unsigned long long L)
{
    map<unsigned long, int, less<unsigned long> > mapa;
    mapa.clear();
    int indexposledniho = 0;
    int pocet = 0;
    for(int i = 0;i<N;i++)
    {

        while(hodnoty[i].first > L && hodnoty[indexposledniho].first < hodnoty[i].first - L)
        {
            mapa[hodnoty[indexposledniho].second]--;
            if(mapa[hodnoty[indexposledniho].second] == 0) mapa.erase(mapa.find(hodnoty[indexposledniho].second));
            indexposledniho++;
        }

        unsigned long minimum;
        if(mapa.size() > 0)
        {
            minimum = (*(--mapa.end())).first;
        } else {
            minimum = 0;
        }

        mapa[hodnoty[i].second]++;
        if(i - indexposledniho == 0) continue;

        if(gt)
        {
            if(hodnoty[i].second > minimum) pocet++;
        } else {
            if(hodnoty[i].second < minimum) pocet++;
        }


    }
    return pocet;
}

unsigned long long findavg(bool gt, unsigned long long L)
{
    int indexposledniho = 0;
    int pocet = 0;
    for(int i = 0;i<N;i++)
    {
        while(hodnoty[i].first > L && hodnoty[indexposledniho].first < hodnoty[i].first - L)
        {
            indexposledniho++;
        }

        if(i - indexposledniho == 0) continue;
        unsigned long long average = 0;

        for(int j = indexposledniho;j<i;j++)
        {
            average += hodnoty[j].second;
        }
        average /= (i - indexposledniho);


        if(gt)
        {
            if(hodnoty[i].second > average) pocet++;
        } else {
            if(hodnoty[i].second < average) pocet++;
        }

    }
    return pocet;
}

int main()
{
    char buff[5];
    unsigned long long L;
    while(scanf("%lu", &N) == 1)
    {
        unsigned long long vysledek;
        for(unsigned int i = 0;i<N;i++)
        {
            unsigned long long T;
            unsigned long V;
            scanf("%I64u %lu", &T, &V);
            hodnoty[i] = make_pair(T, V);
        }
        int C;
        scanf("%d", &C);
        for(unsigned int i = 0;i<C;i++)
        {
            bool gt = true;
            scanf("%s", buff);
            if(!strcmp(buff, "lt")) gt = false;
            scanf("%s", buff);
            scanf("%I64u", &L);
            if(!strcmp(buff, "min"))
            {
                vysledek = findmin(gt, L);
            } else if (!strcmp(buff, "max"))
            {
                vysledek = findmax(gt, L);
            } else {
                vysledek = findavg(gt, L);
            }
            printf("%I64u\n", vysledek);
        }
    }
}
