#include <stdio.h>

char displej[112][112];
char novydisplej[112][112];

char* spicky = "<v>^";
char* carky = "-|";
char* carkyflip = "|-";
char* lomitka = "/\\";
char* lomitkaflip = "/\\";

char zpracuj(char* mnozina, int index, int zobrazeni1, int zobrazeni2)
{
    if(zobrazeni1)
    {
        if(mnozina == lomitka)
        {
            mnozina = lomitkaflip;
        } else if (mnozina == spicky){
            switch(index)
            {
                case 0:
                    index = 1;
                    break;
                case 1:
                    index = 0;
                    break;
                case 2:
                    index = 3;
                    break;
                case 3:
                    index = 2;
                    break;
            }
        } else {
            mnozina = carkyflip;
        }
    }


    index += zobrazeni2;
    index %= 4;
    if(mnozina == carky || mnozina == lomitka || mnozina == carkyflip || mnozina == lomitkaflip) index %=2;


    return mnozina[index];
}

int main()
{
    int N;
    while(scanf("%d\n", &N) == 1)
    {
        for(int y = N-1;y>=0;y--)
        {
            for(int x = 0;x<N;x++)
            {
                scanf("%c", &displej[x][y]);
            }
            scanf("\n");
        }

        /*for(int y = 0;y<N;y++)
        {
            for(int x =0;x<N;x++)
            {
                printf("%c", displej[x][y]);
            }
            printf("\n");
        }*/

        char command, divi;
        int zobrazeni1=0, zobrazeni2=0;
        while(true)
        {
            scanf("%c%c", &command, &divi);
            switch(command)
            {
                case '<':
                    zobrazeni2++;
                    break;
                case '>':
                    zobrazeni2+=3;
                    break;
                case '-':
                    zobrazeni1 = !zobrazeni1;
                    if(zobrazeni2 == 3 || zobrazeni2 == 1) zobrazeni2+=2;
                    zobrazeni2 += 3;
                    break;
                case '|':
                    zobrazeni1 = !zobrazeni1;
                    if(zobrazeni2 == 3 || zobrazeni2 == 1) zobrazeni2+=2;
                    zobrazeni2 += 1;
                    break;
                case '\\':
                    zobrazeni1 = !zobrazeni1;
                    if(zobrazeni2 == 3 || zobrazeni2 == 1) zobrazeni2+=2;
                    zobrazeni2 += 2;
                    break;
                case '/':
                    zobrazeni1 = !zobrazeni1;
                    if(zobrazeni2 == 3 || zobrazeni2 == 1) zobrazeni2+=2;
                    break;
            }
            zobrazeni2%=4;

            if(divi == '\n') break;
        }

        for(int y = 0;y<N;y++)
        {
            for(int x = 0;x<N;x++)
            {

                int novex, novey, novex2;
                if(zobrazeni1) {novex = y;novey = x;} else {novex = x;novey=y;}
                for(int i = 0;i<zobrazeni2;i++)
                {
                    novex2 = N - novey - 1;
                    novey = novex;
                    novex = novex2;
                }

                char novychar;

                switch(displej[x][y])
                {
                    case '<':
                        novychar = zpracuj(spicky, 0, zobrazeni1, zobrazeni2);
                        break;
                    case 'v':
                        novychar = zpracuj(spicky, 1, zobrazeni1, zobrazeni2);
                        break;
                    case '>':
                        novychar = zpracuj(spicky, 2, zobrazeni1, zobrazeni2);
                        break;
                    case '^':
                        novychar = zpracuj(spicky, 3, zobrazeni1, zobrazeni2);
                        break;
                    case '|':
                        novychar = zpracuj(carky, 1, zobrazeni1, zobrazeni2);
                        break;
                    case '\\':
                        novychar = zpracuj(lomitka, 1, zobrazeni1, zobrazeni2);
                        break;
                    case '-':
                        novychar = zpracuj(carky, 0, zobrazeni1, zobrazeni2);
                        break;
                    case '/':
                        novychar = zpracuj(lomitka, 0, zobrazeni1, zobrazeni2);
                        break;
                    case 'o':
                        novychar = 'o';
                        break;
                    case 'x':
                        novychar = 'x';
                        break;
                }
                novydisplej[novex][novey] = novychar;

            }

        }
        for(int y = N-1;y>=0;y--)
        {
            for(int x = 0;x<N;x++)
            {
                printf("%c", novydisplej[x][y]);
            }
            printf("\n");
        }
        //printf("\n");

    }



}
