#include <stdio.h>
#include <bitset>

using namespace std;

char tribuna[27][27];
bitset<27> prvnipismenka;
bitset<27> druhapismenka;
bitset<27> tretipismenka;
bitset<27> spravnapismenka;
bitset<27> tedpismenka;

void testuj(int N)
{
    scanf("\n");
    spravnapismenka.reset();
    prvnipismenka.reset();
    druhapismenka.reset();
    tretipismenka.reset();
    for(int x = 0;x<N;x++)
    {
        for(int y = 0;y<N;y++)
        {
            scanf("%c", &tribuna[x][y]);
        }
        scanf("\n");

    }

    for(int y = 0;y<N;y++)
    {
        prvnipismenka.set(tribuna[y][0] - 'A');
    }
    for(int y = 0;y<N;y++)
    {
        druhapismenka.set(tribuna[y][1] - 'A');
    }
    for(int y = 0;y<N;y++)
    {
        tretipismenka.set(tribuna[y][2] - 'A');
    }

    if((prvnipismenka ^ druhapismenka).count() == 0)
    {
        spravnapismenka = prvnipismenka;
    } else
    {
        if((prvnipismenka ^ tretipismenka).count() == 0)
        {
            spravnapismenka = prvnipismenka;
        } else {
            spravnapismenka = druhapismenka;
        }
    }


    //cout << spravnapismenka << "\n";

    int spatnyradek;
    int spatnysloupec;
    for(int x = 0;x<N;x++)
    {
        tedpismenka.reset();
        for(int y = 0;y<N;y++)
        {
            if(spravnapismenka[tribuna[x][y] - 'A'] == 0 || tedpismenka[tribuna[x][y] - 'A'] == 1)
            {
                spatnyradek = x;
                goto hop;
            } else {
                tedpismenka[tribuna[x][y] - 'A'] = 1;
            }
        }
    }

hop:
    for(int y = 0;y<N;y++)
    {
        tedpismenka.reset();
        for(int x = 0;x<N;x++)
        {
            if(spravnapismenka[tribuna[x][y] - 'A'] == 0 || tedpismenka[tribuna[x][y] - 'A'] == 1)
            {
                spatnysloupec = y;
                goto hop2;
            } else {
                tedpismenka[tribuna[x][y] - 'A'] = 1;
            }
        }
    }
hop2:
    char chybejici = 0;
    for(int x=0;x<N;x++)
    {
        spravnapismenka[tribuna[spatnyradek][x] - 'A'] = 0;
    }
    for(int x=0;x<27;x++)
    {
        if(spravnapismenka[x] == 1)
        {
            chybejici = x + 'A';
            break;
        }
    }
    printf("%d %d %c\n", spatnyradek+1, spatnysloupec+1, chybejici);
}

/*void testuj(int N)
{
    scanf("\n");
    int pocty[27];
    bitset<26> jsoutu1;
    char prvnirada[27];
    for(int i = 0;i<27;i++)
    {
        pocty[i] = 0;
    }
    bool confirmed = false;
    char c = 0;
    jsoutu1.reset();
    int xx;
    for(xx = 0;xx<N;xx++)
    {
        scanf("%c", &c);
        pocty[c-'A']++;
        jsoutu1.set(c - 'A');
        prvnirada[xx] = c;
    }
    scanf("\n");
    int possiblex = 0;
    int possibley = 0;
    char possiblec = 0;
    bool confirmovaci = false;

    for(xx = 1;xx<N;xx++)
    {
        if(possiblex != 0)
        {
            confirmovaci = true;
        }
        for(int yy = 0;yy<N;yy++)
        {
            scanf("%c", &c);
            pocty[c-'A']++;
            if(confirmovaci)
            {
                jsoutu1[c - 'A'] = 0;
            }

            if(jsoutu1[c - 'A'] == 0)
            {
                if(possiblex == 0)
                {
                    possiblex = yy + 1;
                    possibley = xx + 1;
                    possiblec = c;
                }
            }
        }
        scanf("\n");
        if(confirmovaci) break;

    }
    for(int zbl = xx+1;zbl<N;zbl++)
    {
        for(int yy = 0;yy<N;yy++)
        {
            scanf("%c", &c);
            pocty[c-'A']++;
        }
        scanf("\n");
    }

    char chybi;
    for(int i = 0;i<27;i++)
    {
        if(pocty[i] > 1 && pocty[i] < N)
        {
            chybi = i + 'A';
        }
    }
    if(jsoutu1.count() != 1)
    {
        printf("%d %d %c\n", possibley, possiblex, chybi);

        return;
    } else {
        char hledat = 0;
        for(int i = 0;i<27;i++)
        {
            if(jsoutu1[i] == 1)
            {
                hledat = i + 'A';
                break;
            }
        }
        for(int i = 0;i<N;i++)
        {
            if(prvnirada[i] == hledat)
            {
                printf("%d %d %c\n", 1, i+1, chybi);
            }
        }
    }*/
//}

int main()
{


    int N;
    while(scanf("%d", &N) == 1)
    {
        testuj(N);
    }
}
